#ifndef NISYNC_HARDWARE_CLOCK_IMPL_H_
#define NISYNC_HARDWARE_CLOCK_IMPL_H_

void _nisync_hardware_clock_get_time(struct nisync_hardware_clock *clk,
					u64 *time);
int nisync_hardware_clock_get_time(struct nisync_hardware_clock *clk,
					u64 *time);

int _nisync_hardware_clock_set_time(struct nisync_hardware_clock *clk,
					u64 time);
int nisync_hardware_clock_set_time(struct nisync_hardware_clock *clk,
					u64 time);

int _nisync_hardware_clock_reset_time(struct nisync_hardware_clock *clk);

int _nisync_hardware_clock_adjust_time(struct nisync_hardware_clock *clk,
					s64 offset);
int nisync_hardware_clock_adjust_time(struct nisync_hardware_clock *clk,
					s64 offset);

int nisync_hardware_clock_get_adj_rate(struct nisync_hardware_clock *clk,
					s32 *rate_in_ps_per_sec);

int _nisync_hardware_clock_set_adj_rate(struct nisync_hardware_clock *clk,
					const s32 rate_in_ps_per_sec);
int nisync_hardware_clock_set_adj_rate(struct nisync_hardware_clock *clk,
					const s32 rate_in_ps_per_sec);

int nisync_hardware_clock_get_frequency(struct nisync_hardware_clock *clk,
					u32 *frequency);
int nisync_hardware_clock_set_frequency(struct nisync_hardware_clock *clk,
					u32 frequency);

#endif /* NISYNC_HARDWARE_CLOCK_IMPL_H_ */
